<?php
/**
 * Plugin Name: DX Webp Picture Tag Image Wrapper
 * Version: 1.0.0
 * Description: The plugin wraps content images in picture tag by making one of the sources webp. It supports Gutenberg content
 * Author: DevriX
 * Author URI: https://www.devrix.com/
 * Text Domain: dx_pt
 */


function dx_pt_replace_img_with_picture( $content ) {
	$pattern = "/<img\s(?(?=src=\")(src=\"(.*)\"[^>]+>)|(.*src=\"(.*)\".*srcset=\"(.*)\".*sizes=\"(.*)\"[^>]+>))/mU";

	return preg_replace_callback( $pattern, function ( $matches ) {
		$content = "<picture>";

		//Get the srcset value, if it doesn't exist, use the src instead
		$srcset_value = $matches[2];
		if ( isset( $matches[5] ) ) {
			$srcset_value = $matches[5];
		}

		//Get sizes, if they exist
		$sizes = '';
		if ( isset( $matches[6] ) ) {
			$sizes = "sizes=\"$matches[6]\"";
		}

		// Adding webp
		$content .= "<source type='image/webp' srcset=\"$srcset_value\" $sizes>";
		$content = str_replace( '.jpg ', '.jpg.webp ', $content );
		$content = str_replace( '.jpeg ', '.jpeg.webp ', $content );
		$content = str_replace( '.png ', '.png.webp ', $content );


		// Adding optimal.jpg
		$content      .= "<source type='image/jpeg' srcset=\"$srcset_value\" $sizes>";

		// Adding img tag
		$content    .= $matches[0];
		$content    .= "</picture>";

		return $content;
	}, $content );
}

add_filter( 'the_content', 'dx_pt_replace_img_with_picture', 20 );